#coding:utf8
"""
@file
@brief  Contains TableFormula, inherits from all classes TableFormula*
"""


from .tableformulastat      import TableFormulaStat
from .tableformulagraph     import TableFormulaGraph
from .tableformula          import TableFormulaCore
from .tableformulamapreduce import TableFormulaMapReduce


class TableFormula (TableFormulaGraph, TableFormulaMapReduce, TableFormulaStat) :
    """
    this class should be used if you do not know what kind of use
    you will have (stat, graph, basic operations...)
    """
    
    def __init__ (self, file, 
                        numeric_column  = [], 
                        sep             = "\t",
                        encoding        = None,
                        read_n_lines    = -1,
                        sheet           = 0,
                        **options) :
        """
        constructor, see `TableFormulaCore.__init__ <pyhome3.srcpyhome.tables.tableformulas.tableformula.TableFormulaCore.__init__>`
        """
        if isinstance(file, TableFormulaCore) :
            TableFormulaGraph.__init__ (self, file.header, file.values, **options)
        else :
            TableFormulaGraph.__init__ (self, file = file, 
                                              numeric_column = numeric_column, 
                                              sep = sep, 
                                              encoding = encoding,
                                              read_n_lines = read_n_lines,
                                              sheet = sheet, 
                                              **options) 
            
